/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIX509Cert.idl
 */

#ifndef __gen_nsIX509Cert_h__
#define __gen_nsIX509Cert_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIArray; /* forward declaration */

class nsIX509CertValidity; /* forward declaration */

class nsIASN1Object; /* forward declaration */


/* starting interface:    nsIX509Cert */
#define NS_IX509CERT_IID_STR "f0980f60-ee3d-11d4-998b-00b0d02354a0"

#define NS_IX509CERT_IID \
  {0xf0980f60, 0xee3d, 0x11d4, \
    { 0x99, 0x8b, 0x00, 0xb0, 0xd0, 0x23, 0x54, 0xa0 }}

class NS_NO_VTABLE nsIX509Cert : public nsISupports {
 public: 

  NS_DEFINE_STATIC_IID_ACCESSOR(NS_IX509CERT_IID)

  /* readonly attribute AString nickname; */
  NS_IMETHOD GetNickname(nsAString & aNickname) = 0;

  /* readonly attribute AString emailAddress; */
  NS_IMETHOD GetEmailAddress(nsAString & aEmailAddress) = 0;

  /* readonly attribute AString commonName; */
  NS_IMETHOD GetCommonName(nsAString & aCommonName) = 0;

  /* readonly attribute AString organization; */
  NS_IMETHOD GetOrganization(nsAString & aOrganization) = 0;

  /* readonly attribute AString organizationalUnit; */
  NS_IMETHOD GetOrganizationalUnit(nsAString & aOrganizationalUnit) = 0;

  /* readonly attribute AString subjectName; */
  NS_IMETHOD GetSubjectName(nsAString & aSubjectName) = 0;

  /* readonly attribute AString issuerName; */
  NS_IMETHOD GetIssuerName(nsAString & aIssuerName) = 0;

  /* readonly attribute AString serialNumber; */
  NS_IMETHOD GetSerialNumber(nsAString & aSerialNumber) = 0;

  /* readonly attribute AString sha1Fingerprint; */
  NS_IMETHOD GetSha1Fingerprint(nsAString & aSha1Fingerprint) = 0;

  /* readonly attribute AString md5Fingerprint; */
  NS_IMETHOD GetMd5Fingerprint(nsAString & aMd5Fingerprint) = 0;

  /* readonly attribute AString issuedDate; */
  NS_IMETHOD GetIssuedDate(nsAString & aIssuedDate) = 0;

  /* readonly attribute AString issuedDateSortable; */
  NS_IMETHOD GetIssuedDateSortable(nsAString & aIssuedDateSortable) = 0;

  /* readonly attribute AString expiresDate; */
  NS_IMETHOD GetExpiresDate(nsAString & aExpiresDate) = 0;

  /* readonly attribute AString expiresDateSortable; */
  NS_IMETHOD GetExpiresDateSortable(nsAString & aExpiresDateSortable) = 0;

  /* readonly attribute AString tokenName; */
  NS_IMETHOD GetTokenName(nsAString & aTokenName) = 0;

  /* readonly attribute AString issuerCommonName; */
  NS_IMETHOD GetIssuerCommonName(nsAString & aIssuerCommonName) = 0;

  /* readonly attribute AString issuerOrganization; */
  NS_IMETHOD GetIssuerOrganization(nsAString & aIssuerOrganization) = 0;

  /* readonly attribute AString issuerOrganizationUnit; */
  NS_IMETHOD GetIssuerOrganizationUnit(nsAString & aIssuerOrganizationUnit) = 0;

  /* readonly attribute nsIX509Cert issuer; */
  NS_IMETHOD GetIssuer(nsIX509Cert * *aIssuer) = 0;

  /* readonly attribute nsIX509CertValidity validity; */
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity) = 0;

  /* readonly attribute string dbKey; */
  NS_IMETHOD GetDbKey(char * *aDbKey) = 0;

  /* readonly attribute string windowTitle; */
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle) = 0;

  /* readonly attribute boolean usesOCSP; */
  NS_IMETHOD GetUsesOCSP(PRBool *aUsesOCSP) = 0;

  enum { UNKNOWN_CERT = 0U };

  enum { CA_CERT = 1U };

  enum { USER_CERT = 2U };

  enum { EMAIL_CERT = 4U };

  enum { SERVER_CERT = 8U };

  enum { VERIFIED_OK = 0U };

  enum { NOT_VERIFIED_UNKNOWN = 1U };

  enum { CERT_REVOKED = 2U };

  enum { CERT_EXPIRED = 4U };

  enum { CERT_NOT_TRUSTED = 8U };

  enum { ISSUER_NOT_TRUSTED = 16U };

  enum { ISSUER_UNKNOWN = 32U };

  enum { INVALID_CA = 64U };

  enum { USAGE_NOT_ALLOWED = 128U };

  /* nsIArray getChain (); */
  NS_IMETHOD GetChain(nsIArray **_retval) = 0;

  /* void getUsages (out unsigned long verified, out unsigned long count, [array, size_is (count)] out wstring usages); */
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages) = 0;

  /* void getPurposes (out unsigned long verified, out AString purposes); */
  NS_IMETHOD GetPurposes(PRUint32 *verified, nsAString & purposes) = 0;

  enum { CERT_USAGE_SSLClient = 0U };

  enum { CERT_USAGE_SSLServer = 1U };

  enum { CERT_USAGE_SSLServerWithStepUp = 2U };

  enum { CERT_USAGE_SSLCA = 3U };

  enum { CERT_USAGE_EmailSigner = 4U };

  enum { CERT_USAGE_EmailRecipient = 5U };

  enum { CERT_USAGE_ObjectSigner = 6U };

  enum { CERT_USAGE_UserCertImport = 7U };

  enum { CERT_USAGE_VerifyCA = 8U };

  enum { CERT_USAGE_ProtectedObjectSigner = 9U };

  enum { CERT_USAGE_StatusResponder = 10U };

  enum { CERT_USAGE_AnyCA = 11U };

  /* unsigned long verifyForUsage (in unsigned long usage); */
  NS_IMETHOD VerifyForUsage(PRUint32 usage, PRUint32 *_retval) = 0;

  /* readonly attribute nsIASN1Object ASN1Structure; */
  NS_IMETHOD GetASN1Structure(nsIASN1Object * *aASN1Structure) = 0;

  /* void getRawDER (out unsigned long length, [array, size_is (length), retval] out octet data); */
  NS_IMETHOD GetRawDER(PRUint32 *length, PRUint8 **data) = 0;

  /* boolean isSameCert (in nsIX509Cert other); */
  NS_IMETHOD IsSameCert(nsIX509Cert *other, PRBool *_retval) = 0;

};

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIX509CERT \
  NS_IMETHOD GetNickname(nsAString & aNickname); \
  NS_IMETHOD GetEmailAddress(nsAString & aEmailAddress); \
  NS_IMETHOD GetCommonName(nsAString & aCommonName); \
  NS_IMETHOD GetOrganization(nsAString & aOrganization); \
  NS_IMETHOD GetOrganizationalUnit(nsAString & aOrganizationalUnit); \
  NS_IMETHOD GetSubjectName(nsAString & aSubjectName); \
  NS_IMETHOD GetIssuerName(nsAString & aIssuerName); \
  NS_IMETHOD GetSerialNumber(nsAString & aSerialNumber); \
  NS_IMETHOD GetSha1Fingerprint(nsAString & aSha1Fingerprint); \
  NS_IMETHOD GetMd5Fingerprint(nsAString & aMd5Fingerprint); \
  NS_IMETHOD GetIssuedDate(nsAString & aIssuedDate); \
  NS_IMETHOD GetIssuedDateSortable(nsAString & aIssuedDateSortable); \
  NS_IMETHOD GetExpiresDate(nsAString & aExpiresDate); \
  NS_IMETHOD GetExpiresDateSortable(nsAString & aExpiresDateSortable); \
  NS_IMETHOD GetTokenName(nsAString & aTokenName); \
  NS_IMETHOD GetIssuerCommonName(nsAString & aIssuerCommonName); \
  NS_IMETHOD GetIssuerOrganization(nsAString & aIssuerOrganization); \
  NS_IMETHOD GetIssuerOrganizationUnit(nsAString & aIssuerOrganizationUnit); \
  NS_IMETHOD GetIssuer(nsIX509Cert * *aIssuer); \
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity); \
  NS_IMETHOD GetDbKey(char * *aDbKey); \
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle); \
  NS_IMETHOD GetUsesOCSP(PRBool *aUsesOCSP); \
  NS_IMETHOD GetChain(nsIArray **_retval); \
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages); \
  NS_IMETHOD GetPurposes(PRUint32 *verified, nsAString & purposes); \
  NS_IMETHOD VerifyForUsage(PRUint32 usage, PRUint32 *_retval); \
  NS_IMETHOD GetASN1Structure(nsIASN1Object * *aASN1Structure); \
  NS_IMETHOD GetRawDER(PRUint32 *length, PRUint8 **data); \
  NS_IMETHOD IsSameCert(nsIX509Cert *other, PRBool *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIX509CERT(_to) \
  NS_IMETHOD GetNickname(nsAString & aNickname) { return _to GetNickname(aNickname); } \
  NS_IMETHOD GetEmailAddress(nsAString & aEmailAddress) { return _to GetEmailAddress(aEmailAddress); } \
  NS_IMETHOD GetCommonName(nsAString & aCommonName) { return _to GetCommonName(aCommonName); } \
  NS_IMETHOD GetOrganization(nsAString & aOrganization) { return _to GetOrganization(aOrganization); } \
  NS_IMETHOD GetOrganizationalUnit(nsAString & aOrganizationalUnit) { return _to GetOrganizationalUnit(aOrganizationalUnit); } \
  NS_IMETHOD GetSubjectName(nsAString & aSubjectName) { return _to GetSubjectName(aSubjectName); } \
  NS_IMETHOD GetIssuerName(nsAString & aIssuerName) { return _to GetIssuerName(aIssuerName); } \
  NS_IMETHOD GetSerialNumber(nsAString & aSerialNumber) { return _to GetSerialNumber(aSerialNumber); } \
  NS_IMETHOD GetSha1Fingerprint(nsAString & aSha1Fingerprint) { return _to GetSha1Fingerprint(aSha1Fingerprint); } \
  NS_IMETHOD GetMd5Fingerprint(nsAString & aMd5Fingerprint) { return _to GetMd5Fingerprint(aMd5Fingerprint); } \
  NS_IMETHOD GetIssuedDate(nsAString & aIssuedDate) { return _to GetIssuedDate(aIssuedDate); } \
  NS_IMETHOD GetIssuedDateSortable(nsAString & aIssuedDateSortable) { return _to GetIssuedDateSortable(aIssuedDateSortable); } \
  NS_IMETHOD GetExpiresDate(nsAString & aExpiresDate) { return _to GetExpiresDate(aExpiresDate); } \
  NS_IMETHOD GetExpiresDateSortable(nsAString & aExpiresDateSortable) { return _to GetExpiresDateSortable(aExpiresDateSortable); } \
  NS_IMETHOD GetTokenName(nsAString & aTokenName) { return _to GetTokenName(aTokenName); } \
  NS_IMETHOD GetIssuerCommonName(nsAString & aIssuerCommonName) { return _to GetIssuerCommonName(aIssuerCommonName); } \
  NS_IMETHOD GetIssuerOrganization(nsAString & aIssuerOrganization) { return _to GetIssuerOrganization(aIssuerOrganization); } \
  NS_IMETHOD GetIssuerOrganizationUnit(nsAString & aIssuerOrganizationUnit) { return _to GetIssuerOrganizationUnit(aIssuerOrganizationUnit); } \
  NS_IMETHOD GetIssuer(nsIX509Cert * *aIssuer) { return _to GetIssuer(aIssuer); } \
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity) { return _to GetValidity(aValidity); } \
  NS_IMETHOD GetDbKey(char * *aDbKey) { return _to GetDbKey(aDbKey); } \
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle) { return _to GetWindowTitle(aWindowTitle); } \
  NS_IMETHOD GetUsesOCSP(PRBool *aUsesOCSP) { return _to GetUsesOCSP(aUsesOCSP); } \
  NS_IMETHOD GetChain(nsIArray **_retval) { return _to GetChain(_retval); } \
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages) { return _to GetUsages(verified, count, usages); } \
  NS_IMETHOD GetPurposes(PRUint32 *verified, nsAString & purposes) { return _to GetPurposes(verified, purposes); } \
  NS_IMETHOD VerifyForUsage(PRUint32 usage, PRUint32 *_retval) { return _to VerifyForUsage(usage, _retval); } \
  NS_IMETHOD GetASN1Structure(nsIASN1Object * *aASN1Structure) { return _to GetASN1Structure(aASN1Structure); } \
  NS_IMETHOD GetRawDER(PRUint32 *length, PRUint8 **data) { return _to GetRawDER(length, data); } \
  NS_IMETHOD IsSameCert(nsIX509Cert *other, PRBool *_retval) { return _to IsSameCert(other, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIX509CERT(_to) \
  NS_IMETHOD GetNickname(nsAString & aNickname) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetNickname(aNickname); } \
  NS_IMETHOD GetEmailAddress(nsAString & aEmailAddress) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetEmailAddress(aEmailAddress); } \
  NS_IMETHOD GetCommonName(nsAString & aCommonName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetCommonName(aCommonName); } \
  NS_IMETHOD GetOrganization(nsAString & aOrganization) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOrganization(aOrganization); } \
  NS_IMETHOD GetOrganizationalUnit(nsAString & aOrganizationalUnit) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOrganizationalUnit(aOrganizationalUnit); } \
  NS_IMETHOD GetSubjectName(nsAString & aSubjectName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSubjectName(aSubjectName); } \
  NS_IMETHOD GetIssuerName(nsAString & aIssuerName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerName(aIssuerName); } \
  NS_IMETHOD GetSerialNumber(nsAString & aSerialNumber) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSerialNumber(aSerialNumber); } \
  NS_IMETHOD GetSha1Fingerprint(nsAString & aSha1Fingerprint) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetSha1Fingerprint(aSha1Fingerprint); } \
  NS_IMETHOD GetMd5Fingerprint(nsAString & aMd5Fingerprint) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetMd5Fingerprint(aMd5Fingerprint); } \
  NS_IMETHOD GetIssuedDate(nsAString & aIssuedDate) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuedDate(aIssuedDate); } \
  NS_IMETHOD GetIssuedDateSortable(nsAString & aIssuedDateSortable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuedDateSortable(aIssuedDateSortable); } \
  NS_IMETHOD GetExpiresDate(nsAString & aExpiresDate) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExpiresDate(aExpiresDate); } \
  NS_IMETHOD GetExpiresDateSortable(nsAString & aExpiresDateSortable) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetExpiresDateSortable(aExpiresDateSortable); } \
  NS_IMETHOD GetTokenName(nsAString & aTokenName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTokenName(aTokenName); } \
  NS_IMETHOD GetIssuerCommonName(nsAString & aIssuerCommonName) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerCommonName(aIssuerCommonName); } \
  NS_IMETHOD GetIssuerOrganization(nsAString & aIssuerOrganization) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerOrganization(aIssuerOrganization); } \
  NS_IMETHOD GetIssuerOrganizationUnit(nsAString & aIssuerOrganizationUnit) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuerOrganizationUnit(aIssuerOrganizationUnit); } \
  NS_IMETHOD GetIssuer(nsIX509Cert * *aIssuer) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetIssuer(aIssuer); } \
  NS_IMETHOD GetValidity(nsIX509CertValidity * *aValidity) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetValidity(aValidity); } \
  NS_IMETHOD GetDbKey(char * *aDbKey) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDbKey(aDbKey); } \
  NS_IMETHOD GetWindowTitle(char * *aWindowTitle) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetWindowTitle(aWindowTitle); } \
  NS_IMETHOD GetUsesOCSP(PRBool *aUsesOCSP) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUsesOCSP(aUsesOCSP); } \
  NS_IMETHOD GetChain(nsIArray **_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetChain(_retval); } \
  NS_IMETHOD GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetUsages(verified, count, usages); } \
  NS_IMETHOD GetPurposes(PRUint32 *verified, nsAString & purposes) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPurposes(verified, purposes); } \
  NS_IMETHOD VerifyForUsage(PRUint32 usage, PRUint32 *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->VerifyForUsage(usage, _retval); } \
  NS_IMETHOD GetASN1Structure(nsIASN1Object * *aASN1Structure) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetASN1Structure(aASN1Structure); } \
  NS_IMETHOD GetRawDER(PRUint32 *length, PRUint8 **data) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetRawDER(length, data); } \
  NS_IMETHOD IsSameCert(nsIX509Cert *other, PRBool *_retval) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsSameCert(other, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsX509Cert : public nsIX509Cert
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIX509CERT

  nsX509Cert();
  virtual ~nsX509Cert();
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsX509Cert, nsIX509Cert)

nsX509Cert::nsX509Cert()
{
  NS_INIT_ISUPPORTS();
  /* member initializers and constructor code */
}

nsX509Cert::~nsX509Cert()
{
  /* destructor code */
}

/* readonly attribute AString nickname; */
NS_IMETHODIMP nsX509Cert::GetNickname(nsAString & aNickname)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString emailAddress; */
NS_IMETHODIMP nsX509Cert::GetEmailAddress(nsAString & aEmailAddress)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString commonName; */
NS_IMETHODIMP nsX509Cert::GetCommonName(nsAString & aCommonName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString organization; */
NS_IMETHODIMP nsX509Cert::GetOrganization(nsAString & aOrganization)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString organizationalUnit; */
NS_IMETHODIMP nsX509Cert::GetOrganizationalUnit(nsAString & aOrganizationalUnit)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString subjectName; */
NS_IMETHODIMP nsX509Cert::GetSubjectName(nsAString & aSubjectName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuerName; */
NS_IMETHODIMP nsX509Cert::GetIssuerName(nsAString & aIssuerName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString serialNumber; */
NS_IMETHODIMP nsX509Cert::GetSerialNumber(nsAString & aSerialNumber)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString sha1Fingerprint; */
NS_IMETHODIMP nsX509Cert::GetSha1Fingerprint(nsAString & aSha1Fingerprint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString md5Fingerprint; */
NS_IMETHODIMP nsX509Cert::GetMd5Fingerprint(nsAString & aMd5Fingerprint)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuedDate; */
NS_IMETHODIMP nsX509Cert::GetIssuedDate(nsAString & aIssuedDate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuedDateSortable; */
NS_IMETHODIMP nsX509Cert::GetIssuedDateSortable(nsAString & aIssuedDateSortable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString expiresDate; */
NS_IMETHODIMP nsX509Cert::GetExpiresDate(nsAString & aExpiresDate)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString expiresDateSortable; */
NS_IMETHODIMP nsX509Cert::GetExpiresDateSortable(nsAString & aExpiresDateSortable)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString tokenName; */
NS_IMETHODIMP nsX509Cert::GetTokenName(nsAString & aTokenName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuerCommonName; */
NS_IMETHODIMP nsX509Cert::GetIssuerCommonName(nsAString & aIssuerCommonName)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuerOrganization; */
NS_IMETHODIMP nsX509Cert::GetIssuerOrganization(nsAString & aIssuerOrganization)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute AString issuerOrganizationUnit; */
NS_IMETHODIMP nsX509Cert::GetIssuerOrganizationUnit(nsAString & aIssuerOrganizationUnit)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIX509Cert issuer; */
NS_IMETHODIMP nsX509Cert::GetIssuer(nsIX509Cert * *aIssuer)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIX509CertValidity validity; */
NS_IMETHODIMP nsX509Cert::GetValidity(nsIX509CertValidity * *aValidity)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string dbKey; */
NS_IMETHODIMP nsX509Cert::GetDbKey(char * *aDbKey)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute string windowTitle; */
NS_IMETHODIMP nsX509Cert::GetWindowTitle(char * *aWindowTitle)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean usesOCSP; */
NS_IMETHODIMP nsX509Cert::GetUsesOCSP(PRBool *aUsesOCSP)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIArray getChain (); */
NS_IMETHODIMP nsX509Cert::GetChain(nsIArray **_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getUsages (out unsigned long verified, out unsigned long count, [array, size_is (count)] out wstring usages); */
NS_IMETHODIMP nsX509Cert::GetUsages(PRUint32 *verified, PRUint32 *count, PRUnichar ***usages)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getPurposes (out unsigned long verified, out AString purposes); */
NS_IMETHODIMP nsX509Cert::GetPurposes(PRUint32 *verified, nsAString & purposes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* unsigned long verifyForUsage (in unsigned long usage); */
NS_IMETHODIMP nsX509Cert::VerifyForUsage(PRUint32 usage, PRUint32 *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIASN1Object ASN1Structure; */
NS_IMETHODIMP nsX509Cert::GetASN1Structure(nsIASN1Object * *aASN1Structure)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void getRawDER (out unsigned long length, [array, size_is (length), retval] out octet data); */
NS_IMETHODIMP nsX509Cert::GetRawDER(PRUint32 *length, PRUint8 **data)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isSameCert (in nsIX509Cert other); */
NS_IMETHODIMP nsX509Cert::IsSameCert(nsIX509Cert *other, PRBool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIX509Cert_h__ */
